<?php
require_once( PALOOSE_LIB_DIRECTORY . "/environment/Environment.php" );
require_once( PALOOSE_LIB_DIRECTORY . "/acting/Action.php" );
require_once( PALOOSE_LIB_DIRECTORY . "/acting/ActionPipeElement.php" );
require_once( PALOOSE_LIB_DIRECTORY . "/pipelines/PipeElement.php" );
require_once( PALOOSE_LIB_DIRECTORY . "/pipelines/PipeElementInterface.php" );
require_once( PALOOSE_LIB_DIRECTORY . "/sitemap/Parameter.php" );
class SendMailAction extends ActionPipeElement implements PipeElementInterface
{
       
   private $gSMTPHost;
   
   private $gSMTPUser;
   
   private $gSMTPPassword;
   private $gFrom;
   private $gTo;
   private $gSubject;
   private $gBody;
   private $gCC;
   private $gBCC;
   private $gAttachments;
   
   
   
   public function __construct( DOMDocument $inDOM, $inType = "", $inSrc = "", $inComponent = NULL )
   {
      try {
         parent::__construct( $inDOM, $inType, $inSrc, $inComponent );
      } catch ( UserException $e ) {
         throw new UserException( $e->getMessage(), $e->getCode(), $e->getDOMScrap() );
      }
      $this->gSMTPUser = $this->gComponent->gSMTPUser;
      $this->gSMTPHost = $this->gComponent->gSMTPHost;
      $this->gSMTPPassword = $this->gComponent->gSMTPPassword;
   }
   
   
   
   public function run( VariableStack $inVariableStack, $inURL, $inQueryString, DOMDocument $inDOM )
   {
      $smtpHost = StringResolver::expandString( $inVariableStack, $this->gParameters->getParameter( "smtp-host" ) );
      $smtpUser = StringResolver::expandString( $inVariableStack, $this->gParameters->getParameter( "smtp-user" ) );
      $smtpPassword = StringResolver::expandString( $inVariableStack, $this->gParameters->getParameter( "smtp-password" ) );
      $from = StringResolver::expandString( $inVariableStack, $this->gParameters->getParameter( "from" ) );
      $to = StringResolver::expandString( $inVariableStack, $this->gParameters->getParameter( "to" ) );
      $subject = StringResolver::expandString( $inVariableStack, $this->gParameters->getParameter( "subject" ) );
      $message = StringResolver::expandString( $inVariableStack, $this->gParameters->getParameter( "body" ) );
      $cc = StringResolver::expandString( $inVariableStack, $this->gParameters->getParameter( "cc" ) );
      $bcc = StringResolver::expandString( $inVariableStack, $this->gParameters->getParameter( "bcc" ) );
      $attachments = StringResolver::expandString( $inVariableStack, $this->gParameters->getParameter( "attachments" ) );
      
      $headers = "From: $from" . "\r\n" .
                  "Cc: $cc" . "\r\n" .
                  "Bcc: $bcc" . "\r\n";
      
      
      $success = mail( $to, $subject, $message, $headers );
      
      try {
         if ( $success == 1 ) {
            $this->gPipe->run( Environment::$variableStack, $inURL, $inQueryString, $inDOM );
            
            
            
            throw new ExitException();
         } else {
            
            return $inDOM;
         }
      } catch ( ExitException $e ) {
         throw new ExitException();
      } catch ( UserException $e ) {
         throw new UserException( $e->getMessage(), $e->getCode(), $e->getDOMScrap() );
      } catch ( RunException $e ) {
         throw new RunException( $e->getMessage(), $e->getCode() );
      }
      return NULL;
   }
   
   
   
  
   public function toString()
   {
      if ( $this->gPipe != null or $this->gParameters != NULL ) {
         $mess = "     <act type='{$this->gType}'>\n";
          if ( $this->gParameters != NULL ) {
            $mess .= $this->gParameters->toString();
         }
          if ( $this->gPipe != NULL ) {
            $mess .= $this->gPipe->toString();
         }
         $mess .= "     </act>\n";
         return $mess;
      } else {
         $mess = "   <act type='{$this->gType}'/>\n";
      }
   }
}
 
class _SendMailAction extends Action {
    
   
   public $gSMTPHost;
   
   public $gSMTPUser;
   
   public $gSMTPPassword;
   
   
   
   
   public function __construct( $inName, $inSrc, DOMNode $inParameterNode, $inIsCachable )
   {
      parent::__construct( $inName, $inSrc, $inParameterNode, $inIsCachable );
      $this->gSMTPHost = "";
      $this->gSMTPUser = "";
      $this->gSMTPPassword = "";
      $this->gPackageName = "SendMailAction";
      $parameterDOM = new DOMDocument;
      $parameterDOM->appendChild( $parameterDOM->importNode( $inParameterNode, 1 ) );
      $xpath = new domxpath( $parameterDOM );
      $xpath->registerNamespace( "m", Environment::$configuration[ 'sitemapNamespace' ] );
      
      $this->gSMTPHost = Utilities::getXPathListStringItem( 0, $xpath, "//smtp-host" );
      $this->gSMTPUser = Utilities::getXPathListStringItem( 0, $xpath, "//smtp-user" );
      $this->gSMTPPassword = Utilities::getXPathListStringItem( 0, $xpath, "//smtp-password" );
  }
   
   
   
   public function toString()
   {
      if ( $this->gParameters != NULL or strlen( $this->gSMTPHost ) > 0 or strlen( $this->gSMTPUser ) > 0 or strlen( $this->gSMTPPassword ) > 0 ) {
         $mess = "   <action name='{$this->gName}' src='{$this->gSrc}' package='{$this->gPackageName}'>\n";
         if ( $this->gParameters != NULL ) {
            while ( list( $name, $value ) = each( $this->gParameters ) ) {
               $mess .= "    <parameter name='$name' value='$value'/>\n";
            }
            reset( $this->gParameters ); 
         }
         
         if ( strlen( $this->gSMTPHost ) > 0 ) {
            $mess .= "      <smtp-host>{$this->gSMTPHost}</smtp-host>\n";
         }
         if ( strlen( $this->gSMTPUser ) > 0 ) {
            $mess .= "      <smtp-user>{$this->gSMTPUser}</smtp-user>\n";
         }
         if ( strlen( $this->gSMTPPassword ) > 0 ) {
            $mess .= "      <smtp-password>{$this->gSMTPPassword}</smtp-password>\n";
         }
         $mess .= "   </action>\n";
      } else {
         $mess = "   <action name='{$this->gName}' src='{$this->gSrc}' package='{$this->gPackageName}'/>\n";
      }
      return $mess;
   }
}
?>
