<?php
 
class Browser{ 
   private $gName = "Unknown";
   
   private $gVersion = "Unknown";
   
   private $gPlatform = "Unknown";
   
   private $gUserAgent = "Not reported";
   
   private $gAOL = false;
   
   
   
   public function __construct()
   { 
      $agent = $_SERVER[ 'HTTP_USER_AGENT' ];
      
      $bd[ 'platform' ] = "Unknown";
      $bd[ 'browser' ] = "Unknown";
      $bd[ 'version' ] = "Unknown";
      $this->gUserAgent = $agent;
      
      if ( preg_match( "/win/i", $agent ) )
         $bd[ 'platform' ] = "Windows";
      elseif ( preg_match( "/mac/i", $agent ) ) 
         $bd[ 'platform' ] = "MacIntosh";
      elseif ( preg_match( "/linux/i", $agent ) ) 
         $bd[ 'platform' ] = "Linux";
      elseif ( preg_match( "/OS\/2/i", $agent ) ) 
         $bd[ 'platform' ] = "OS/2";
      elseif ( preg_match( "/BeOS/i", $agent ) ) 
         $bd[ 'platform' ] = "BeOS";
      
      if ( preg_match( "/opera/i", $agent ) )  {
         $val = stristr( $agent, "opera" );
         if ( preg_match( "/\//i", $val ) ) {
            $val = explode( "/", $val );
            $bd[ 'browser' ] = $val[0];
            $val = explode( " ", $val[1] );
            $bd[ 'version' ] = $val[0];
         } else { 
            $val = explode( " ", stristr( $val, "opera" ) );
            $bd[ 'browser' ] = $val[0];
            $bd[ 'version' ] = $val[1];
         }
      
      } elseif ( preg_match( "/webtv/i", $agent ) ) {
         $val = explode( "/", stristr( $agent, "webtv" ) );
         $bd[ 'browser' ] = $val[0];
         $bd[ 'version' ] = $val[1];
      
      
      } elseif ( preg_match( "/microsoft internet explorer/i", $agent ) ) {
         $bd[ 'browser' ] = "MSIE";
         $bd[ 'version' ] = "1.0";
         $var = stristr( $agent, "/" );
         if ( ereg( "308|425|426|474|0b1", $var ) )  {
            $bd[ 'version' ] = "1.5";
         }
      
      } elseif ( preg_match( "/NetPositive/i", $agent ) )  {
         $val = explode( "/", stristr( $agent, "NetPositive" ) );
         $bd[ 'platform' ] = "BeOS";
         $bd[ 'browser' ] = $val[0];
         $bd[ 'version' ] = $val[1];
      
      } elseif ( preg_match( "/msie/i", $agent ) && !preg_match( "/opera/i", $agent ) )  {
         $val = explode( " ", stristr( $agent, "msie" ) );
         $bd[ 'browser' ] = $val[0];
         $bd[ 'version' ] = $val[1];
      
      
      } elseif ( preg_match( "/mspie/i", $agent ) || preg_match( "/pocket/i", $agent ) )  {
         $val = explode( " ", stristr( $agent, "mspie" ) );
         $bd[ 'browser' ] = "MSPIE";
         $bd[ 'platform' ] = "WindowsCE";
         if ( preg_match( "/mspie/i", $agent ) )
            $bd[ 'version' ] = $val[1];
         else { 
            $val = explode( "/", $agent );
            $bd[ 'version' ] = $val[1];
         }
         
      
      } elseif ( preg_match( "/galeon/i", $agent ) )  {
         $val = explode( " ", stristr( $agent, "galeon" ) );
         $val = explode( "/", $val[0] );
         $bd[ 'browser' ] = $val[0];
         $bd[ 'version' ] = $val[1];
         
      
      } elseif ( preg_match( "/Konqueror/i", $agent ) ) { 
         $val = explode( " ", stristr( $agent, "Konqueror" ) );
         $val = explode( "/", $val[0] );
         $bd[ 'browser' ] = $val[0];
         $bd[ 'version' ] = $val[1];
         
      
      } elseif ( preg_match( "/icab/i", $agent ) )  {
         $val = explode( " ", stristr( $agent, "icab" ) );
         $bd[ 'browser' ] = $val[0];
         $bd[ 'version' ] = $val[1];
      
      } elseif ( preg_match( "/omniweb/i", $agent ) )  {
         $val = explode( "/", stristr( $agent, "omniweb" ) );
         $bd[ 'browser' ] = $val[0];
         $bd[ 'version' ] = $val[1];
      
      } elseif ( preg_match( "/Phoenix/i", $agent ) )  {
         $bd[ 'browser' ] = "Phoenix";
         $val = explode( "/", stristr( $agent, "Phoenix/" ) );
         $bd[ 'version' ] = $val[1];
      
      
      } elseif ( preg_match( "/firebird/i", $agent ) )  {
         $bd[ 'browser' ]="Firebird";
         $val = stristr( $agent, "Firebird" );
         $val = explode( "/", $val );
         $bd[ 'version' ] = $val[1];
         
      
      } elseif ( preg_match( "/Firefox/i", $agent ) )  {
         $bd[ 'browser' ]="Firefox";
         $val = stristr( $agent, "Firefox" );
         $val = explode( "/", $val );
         $bd[ 'version' ] = $val[1];
         
     
      } elseif ( preg_match( "/mozilla/i", $agent ) && 
         preg_match( "/rv:[0-9].[0-9][a-b]/i", $agent ) && !preg_match( "/netscape/i", $agent ) )  {
         $bd[ 'browser' ] = "Mozilla";
         $val = explode( " ", stristr( $agent, "rv:" ) );
         preg_match( "/rv:[0-9].[0-9][a-b]/i", $agent, $val );
         $bd[ 'version' ] = str_replace( "rv:", "", $val[0] );
         
      
      } elseif ( preg_match( "/mozilla/i", $agent ) &&
         preg_match( "/rv:[0-9]\.[0-9]/i", $agent ) && !preg_match( "/netscape/i", $agent ) )  {
         $bd[ 'browser' ] = "Mozilla";
         $val = explode( " ", stristr( $agent, "rv:" ) );
         preg_match( "/rv:[0-9]\.[0-9]\.[0-9]/i", $agent, $val );
         $bd[ 'version' ] = str_replace( "rv:", "", $val[0] );
      
      
      } elseif ( preg_match( "/libwww/i", $agent ) )  {
         if ( preg_match( "/amaya/i", $agent ) )  {
            $val = explode( "/", stristr( $agent, "amaya" ) );
            $bd[ 'browser' ] = "Amaya";
            $val = explode( " ", $val[1] );
            $bd[ 'version' ] = $val[0];
         } else { 
            $val = explode( "/", $agent );
            $bd[ 'browser' ] = "Lynx";
            $bd[ 'version' ] = $val[1];
         }
      
      
      } elseif ( preg_match( "/iphone/i", $agent ) )  {
         $bd[ 'browser' ] = "iPhone";
         $bd[ 'version' ] = "";
      
      } elseif ( preg_match( "/safari/i", $agent ) )  {
         $bd[ 'browser' ] = "Safari";
         $bd[ 'version' ] = "";
      
      } elseif ( preg_match( "/netscape/i", $agent ) )  {
         $val = explode( " ", stristr( $agent, "netscape" ) );
         $val = explode( "/", $val[0] );
         $bd[ 'browser' ] = $val[0];
         $bd[ 'version' ] = $val[1];
      } elseif ( preg_match( "/mozilla/i", $agent ) && !preg_match( "/rv:[0-9]\.[0-9]\.[0-9]/i", $agent ) )  {
         $val = explode( " ", stristr( $agent, "mozilla" ) );
         $val = explode( "/", $val[0] );
         $bd[ 'browser' ] = "Netscape";
         $bd[ 'version' ] = $val[1];
      }
      
      
      $bd[ 'browser' ] = preg_replace( "/[^a-z,A-Z]/", "", $bd[ 'browser' ] );
      
      $bd[ 'version' ] = preg_replace( "/[^0-9,.,a-z,A-Z]/", "", $bd[ 'version' ] );
      
      
      $bd[ 'aol' ] = "";
      if ( preg_match( "/AOL/i", $agent ) )  {
         $var = stristr( $agent, "AOL" );
         $var = explode( " ", $var );
         $bd[ 'aol' ] = ereg_replace( "[^0-9, ., a-z, A-Z]", "", $var[1] );
      }
      
      
      $this->gName = $bd[ 'browser' ];
      $this->gVersion = $bd[ 'version' ];
      $this->gPlatform = $bd[ 'platform' ];
      $this->gAOL = $bd[ 'aol' ];
   }
   
   
   
   
   public function getName()
   {
      return $this->gName;
   }
   
   
   
   public function getVersion()
   {
      return $this->gVersion;
   }
   
   
   
   public function getPlatform()
   {
      return $this->gPlatform;
   }
   
   
   
   public function getAOL()
   {
      return $this->gAOL;
   }
   
   
   
   public static function patternCheck( $inPattern )
   { 
      $agent = $_SERVER[ 'HTTP_USER_AGENT' ];
      return preg_match( $inPattern, $agent );
   }
   
}
?>
