<?php
 
require_once( PALOOSE_LIB_DIRECTORY . "/environment/Utilities.php" );
require_once( PALOOSE_LIB_DIRECTORY . "/environment/Environment.php" );
require_once( PALOOSE_LIB_DIRECTORY . "/sitemap/VariableStack.php" );
 
class StringResolver {
   
   
   
   public static function expandString( $inVariableStack, $inData )
   {
      
      
      
      
      $outputData = $inData;
      $finished = false;
      $idx = 0;
      while ( !$finished ) {
         
         $lcbPos = strpos( $outputData, '{' );
         $rcbPos = strpos( $outputData, '}' );
         
         if ( $lcbPos === false ) {
            $finished = true;
         } else {
            
            $var = substr( $outputData, $lcbPos+1, $rcbPos-$lcbPos-1 );
            $pair = explode( ":", $var );
            if ( $pair != NULL and sizeof( $pair ) == 2 ) {
               
               $module = Environment::$modules[ $pair[0] ];
               
               $replacementString = $module->get( $pair[1] );
               
               $srcString = substr( $outputData, $lcbPos, $rcbPos - $lcbPos + 1 );
               
               if ( is_string( $replacementString ) ) {
                  $outputData = str_replace( $srcString, $replacementString, $outputData );
               } else {
                  $outputData = $replacementString;
                  return $outputData;
               }
               
            } else {
               
               $var = substr( $outputData, $lcbPos+1, $rcbPos-$lcbPos-1 );
               
               $replacementString = self::processVar( $inVariableStack, $var );
               $srcString = substr( $outputData, $lcbPos, $rcbPos - $lcbPos + 1 );
               
               $outputData = str_replace( $srcString, $replacementString, $outputData );
               
            }
            $idx += $rcbPos;
            if ( $idx >= strlen( $outputData ) ) {
               $finished = true;
            }
         }
      }
      
      return $outputData;
   }
   
   
   
   private static function processVar( $inVariableStack, $inVar )
   { 
      $p = explode( "/", $inVar );
      
      $level = sizeof( $p ) - 1;
      
      $map = $inVariableStack->entryAt( $level );
      $varIndex = $p[ sizeof( $p ) - 1 ];
      
      
      if ( array_key_exists( $varIndex, $map ) ) {
         return $map[ $varIndex ];
      }
      return "";
   } 
   
   
   
   
   public static function expandPseudoProtocols( $inString )
   {
      if ( !is_string( $inString ) ) {
         return $inString;
      }
      $orig = $inString;
      $srcString = "resource://";
      if ( strpos( $inString, $srcString ) !== false ) {
         return str_replace( $srcString, PALOOSE_DIRECTORY . Environment::getPathSeparator(), $inString );
      }
      $srcString = "context://";
      if ( strpos( $inString, $srcString ) !== false ) {
         return str_replace( $srcString, Environment::$configuration[ 'siteRootDirectory' ] . Environment::getPathSeparator(), $inString );
      }
      $srcString = "cocoon://";
      if ( strpos( $inString, $srcString ) !== false ) {
         return str_replace( $srcString, Environment::$gRootSitemapDir . Environment::getPathSeparator(), $inString );
      }
      $srcString = "cocoon:/";
      if ( strpos( $inString, $srcString ) !== false ) {
         return str_replace( $srcString, Environment::$gCurrentSitemapDir . Environment::getPathSeparator(), $inString );
      }
      return $inString;
   }
  
   
   public function removePseudoProtocols( $inString )
   {
      $srcString = "resource://";
      if ( strpos( $inString, $srcString ) !== false ) {
         return str_replace( $srcString, PALOOSE_DIRECTORY . Environment::getPathSeparator(), $inString );
      }
      $srcString = "context://";
      if ( strpos( $inString, $srcString ) !== false ) {
         return str_replace( $srcString, Environment::getContext(), $inString );
      }
      $srcString = "cocoon://";
      if ( strpos( $inString, $srcString ) !== false ) {
         return str_replace( $srcString, "", $inString );
      }
      $srcString = "cocoon:/";
      if ( strpos( $inString, $srcString ) !== false ) {
         return str_replace( $srcString, "", $inString );
      }
      return $inString;
   }
}
?>
