<?php
require_once( PALOOSE_LIB_DIRECTORY . "/environment/Environment.php" );
 
class ErrorPage {
   
   private $gMessage;
   
   private $gErrorCode;
   
   private $gDOMScrap;
      
   private $userExceptionPage;
      
   private $userExceptionTransform;
      
   private $gStyleSheet;
      
   
   
   
   function __construct( $inErrorMessage, $inErrorCode, $inDOMScrap )
   {
      $this->gMessage = $inErrorMessage;
      $this->gErrorCode = $inErrorCode;
      $this->gDOMScrap = $inDOMScrap;
      $this->userExceptionPage = Environment::$configuration[ 'userExceptionPage' ];
      $this->userExceptionTransform = Environment::$configuration[ 'userExceptionTransform' ];
      $this->gStyleSheet = Environment::$configuration[ 'userExceptionStyle' ];
   }
   
   
   
    
   function display()
   {
      $userExceptionPage = StringResolver::expandPseudoProtocols( $this->userExceptionPage );
      $userExceptionTransform = StringResolver::expandPseudoProtocols( $this->userExceptionTransform );
      $styleSheet = StringResolver::expandPseudoProtocols( $this->gStyleSheet );
      
      
      $xsl = new DomDocument(); 
      $xsl->load( $userExceptionTransform );
      
      $proc = new XsltProcessor(); 
      $xsl = $proc->importStylesheet( $xsl );
      
      $proc->setParameter( null, "errorCode", PalooseException::getErrorText( $this->gErrorCode ) ); 
      $proc->setParameter( null, "errorMessage", $this->gMessage );
      if ( $this->gDOMScrap != NULL ) {
         $proc->setParameter( null, "errorContext", $this->gDOMScrap->saveXML() ); 
      }
      $proc->setParameter( null, "styleSheet", $styleSheet ); 
      
      
      $dom = new DOMDocument();
      $dom->load( $userExceptionPage );
      $xformDOM = $proc->transformToDoc( $dom );
      echo $xformDOM->saveXML();
   }
}
?>
