<?php
require_once( PALOOSE_LIB_DIRECTORY . "/environment/ErrorModule.php" );
 
class HandleError {
      
   private $gPipe;
      
   
   
   function __construct()
   {
      $this->gPipe = NULL;
   }
   
   
   
    
   public function parse( $inNode )
   {
      
      $errorHandlerDom = new DOMDocument;
      $errorHandlerDom->appendChild( $errorHandlerDom->importNode( $inNode, 1 ) );
      $this->gXPath = new domxpath( $errorHandlerDom );
      $this->gXPath->registerNamespace( "m", Environment::$configuration[ 'sitemapNamespace' ] );
      
      $component = $this->gXPath->query( "//m:handle-errors/*" );
      $this->gPipe = new Pipe();
      foreach ( $component as $pipeNode ) {
         $name = $pipeNode->localName;
         
         switch ( $name ) {
            case "generate" :
               try {
                  $generator = PipeElement::createGenerator( $pipeNode );
                  
                  $this->gPipe->addComponent( $generator );      
               } catch ( UserException $e ) {
                  throw new UserException( $e->getMessage(), $e->getCode(), $errorHandlerDom );
               }
               break;
            case "transform" :
               try {
                    $transformer = PipeElement::createTransformer( $pipeNode );
                  
                  $this->gPipe->addComponent( $transformer );
               } catch ( UserException $e ) {
                  throw new UserException( $e->getMessage(), $e->getCode(), $errorHandlerDom );
               }
               break;
            case "serialize" :
               try {
                  $serializer = PipeElement::createSerializer( $pipeNode );
                  
                  $this->gPipe->addComponent( $serializer );
               } catch ( UserException $e ) {
                  throw new UserException( $e->getMessage(), $e->getCode(), $errorHandlerDom );
               }
               break;
         }
      }
   }
   
   
   
   public function run( $inURL, $inMess )
   {
      $errorModule = new ErrorModule( 'error' );
      Environment::$modules[ $errorModule->getName() ] = $errorModule;
      $errorModule->add( "message", $inMess );
      $errorModule->add( "style-sheet", Environment::$configuration[ 'userExceptionStyle' ] );
      
      $outputStream = new OutputStream( OutputStream::STANDARD_OUTPUT );
      
      $sitemap = Environment::$sitemapStack->peek();
      $sitemap->setOutputStream( $outputStream );
      try {
         
         $this->gPipe->run( Environment::$variableStack, $inURL, Environment::$gQueryString, NULL );
      } catch ( RunException $e ) {
      }
   } 
   
   
   
   public function toString()
   {
      $mess = " <handle-errors>\n";
      $mess .= $this->gPipe->toString();
      $mess .= " </handle-errors>\n";
      return $mess;
   }
}
?>
