<?php
require_once( PALOOSE_LIB_DIRECTORY . "/environment/Utilities.php" );
require_once( PALOOSE_LIB_DIRECTORY . "/environment/Environment.php" );
require_once( PALOOSE_LIB_DIRECTORY . "/pipelines/PipeElement.php" );
require_once( PALOOSE_LIB_DIRECTORY . "/environment/StringResolver.php" );
require_once( PALOOSE_LIB_DIRECTORY . "/exception-handling/InternalException.php" );
require_once( PALOOSE_LIB_DIRECTORY . "/exception-handling/UserException.php" );
require_once( PALOOSE_LIB_DIRECTORY . "/exception-handling/RunException.php" );
 
class Catalogue {
    
   private $gId;
    
   private $gName;
   
    
   private $gLocation;
    
   
   
   
    
   public function __construct( DOMNode $inNode )
   {
      $catalogueDOM = new DOMDocument;
      $catalogueDOM->appendChild( $catalogueDOM->importNode( $inNode, 1 ) );
      $catalogueNode = $catalogueDOM->getElementsByTagName( "catalogue" );
      $this->gId = $catalogueNode->item( 0 )->getAttribute( "id" );
      $this->gName = $catalogueNode->item( 0 )->getAttribute( "name" );
      $this->gLocation = $catalogueNode->item( 0 )->getAttribute( "location" );
      if ( strlen ( $this->gId ) == 0 ) {
         throw new UserException( "Must have an associated id attribute with catalogue", PalooseException::SITEMAP_I18N_PARSE_ERROR, $catalogueDOM );
      }
      if ( strlen ( $this->gName ) == 0 ) {
         throw new UserException( "Must have an associated name attribute with catalogue", PalooseException::SITEMAP_I18N_PARSE_ERROR, $catalogueDOM );
      }
      if ( strlen ( $this->gLocation ) == 0 ) {
         throw new UserException( "Must have an associated location attribute with catalogue", PalooseException::SITEMAP_I18N_PARSE_ERROR, $catalogueDOM );
      }
      
   }
   
   
   public function getId()
   {
      return $this->gId;
   }
   
   public function getName()
   {
      return $this->gName;
   }
   
   public function getLocation()
   {
      return $this->gLocation;
   }
   
   
   public function toString()
   {
      $mess = "       <catalogue id='{$this->gId}' name='{$this->gName}' location='{$this->gLocation}'/>\n";
      return $mess;
   }
 }
?>
